<style>
    .wallet_table .base_tb_ct tr td, .wallet_table .base_tb_ct tr th{
        padding: 5px 0px;
    }
    .gray_ft{
        color: #888;
    }
    .gray_ft:hover{
        color: #888;
    }
    .unfreeze_tag{
        border: 1px solid #0070e0;
        line-height: 1;
        font-size: 12px;
        padding: 2px;
        border-radius: 3px;
        color: #0070e0;
        transform: scale(0.8);
        display: inline-block;
        margin-left: -4px;
    }
    .vote_table{
        font-size: 14px;
    }
    .deep_blue_ft{
      color: #244763;
    }
    .grid_box{
        box-shadow: 0px 0px 5px #eee;
        border: 1px solid rgba(238, 238, 238, 0.7);
        line-height: 20px;
        border-radius: 3px;
        margin-right: 20px;
    }
    .grid_box .grid_top_header{
        border-bottom: 1px solid #eee;
        line-height: 30px;
    }
    .grid_box .grid_row{
        text-align: center;
        display: flex;
        line-height: 20px;
        justify-content: center;
    }
    .grid_row .grid_col{
        border-right: 1px solid #eeeeee29;
        width: 50%;
        display: flex;
        justify-content: center;
        line-height: 20px;
        white-space: nowrap;
        padding: 0px 10px;
    }
    .grid_row .grid_col:last-child{
        border-right: 0px;
    }
    .grid_box .grid_foot{
        background: rgba(0, 112, 224, 0.7411764705882353);
        color: #fff;
    }
    .small_grid_load_ct{
        width: 20px;
        height: 20px;
    }
    .small_grid_load_ct .load_circle{
        width: 10px;
        height: 10px;
        border: 1px solid #f7f9f8;
        border-left: 1px solid #00000005;
    }
</style>
<template>
    <div>
        {{ bps_data }}
        <div style="display: none;">  {{ action_data }}</div>
        <div class="tb_title">
            <span class="tb_title_txt">{{ lang.web_wallet_view }}</span>
            <template v-if="$route.name == 'monitor_view'">
                <router-link class="tb_btn tb_more_btn" :to="{name: 'accounts_view'}">{{ lang.see_all }}</router-link>
            </template>
            <template v-if="$route.name != 'monitor_view'">
                <table_nav></table_nav>
            </template>
        </div>
        <div class="wallet_table">
            <div class="no_data" v-if="!on_load && !show_data.length">
                当前无数据
            </div>
            <div class="table_config" v-if="(on_load && !this.show_data.length && is_auto_load) || (!is_auto_load && on_load)">
                <div class="fakeloader">
                    <div class="fl spinner4"></div>
                </div>
            </div>
            <div class="tb_ct">
                <table class="base_tb_ct vote_table"  v-if="(!on_load && this.show_data.length) || (is_auto_load && on_load && this.show_data.length)">
                    <thead>
                        <tr>
                                <th>
                                    #
                                </th>
                                <th>
                                    {{ lang.bpname }}
                                </th>
                                <!-- <th>
                                    {{ lang.bound_percent }}
                                </th> -->
                                <!-- <th>
                                    {{ lang.bonus_rate }}
                                </th> -->
                                <th>
                                    {{ lang.votes_received }}
                                </th>
                               <!--  <th>
                                    {{ lang.reward_pool }}
                                </th> -->
                                <!-- <th>
                                    {{ lang.my_vote }}
                                </th> -->
                                <!-- <th>
                                    {{ lang.your_reward }}
                                </th> -->
                                <!-- <th>
                                    {{ lang.redemption }}
                                </th> -->
                                <!-- <th>
                                    {{ lang.action_area }}
                                </th> -->
                        </tr>
                    </thead>
                    <tr v-for="item, index in show_data" v-bind:class="{'': index%2}">
                        <td>
                            {{ index + 1 }}
                        </td>
                        <td>
                            <div class="">
                                <router-link class="blue_ft" :to="{name: 'account_detail_view', params: {account_name: item.name}}">{{ item.name }}</router-link>
                            </div>
                        </td>
                        <!-- <td>
                            <span v-if="is_mobile">{{ lang.bound_percent + ':' }}</span>
                            {{ item.share_percent/100 + '%' }}
                        </td> -->
                        <!-- <td>
                            <span v-if="is_mobile">{{ lang.bonus_rate + ':' }}</span>
                            {{ item.annualized }}
                        </td> -->
                        <td>
                            <span v-if="is_mobile">{{ lang.votes_received + ':' }}</span>
                            {{ split_long_num(item.total_staked) }}
                        </td>
                        <!-- <td>
                            <span v-if="is_mobile">{{ lang.reward_pool + ':' }}</span>
                            {{ split_long_num(item.rewards_pool) }}
                        </td> -->
                        <!-- <td>
                            <span v-if="is_mobile">{{ lang.my_vote + ':' }}</span>
                            <span v-if="!account_name">-</span>

                            <div class="grid_box"  v-if="account_name">
                                <div class="grid_row grid_top_header">
                                    {{ toBigNumber( select_my_vote(item.name).staked ).plus( item.total_fixed_vote  ) }}
                                </div>
                                <div class="grid_row grid_foot">
                                    <div class="grid_col">
                                        <span v-if="!my_vote_list.on_load">
                                            {{ toBigNumber( select_my_vote(item.name).staked ) }}    
                                        </span>
                                        <span v-if="my_vote_list.on_load">
                                            <div class="base_load_ct small_grid_load_ct">
                                                <div class="load_circle"></div>
                                            </div>
                                        </span>
                                    </div>
                                    <div class="grid_col">
                                        <span v-if="!my_fixed_vote.on_load">{{ item.total_fixed_vote }}</span>
                                        <span v-if="my_fixed_vote.on_load">
                                            <div class="base_load_ct small_grid_load_ct">
                                                <div class="load_circle"></div>
                                            </div>
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </td> -->
                        <!-- <td>
                            <span v-if="is_mobile">{{ lang.your_reward + ':' }}</span>
                            <div v-if="!account_name">-</div>
                            <div class="grid_box" v-if="account_name">
                                <div class="grid_row grid_top_header">
                                    {{ toAsset( toBigNumber(parseFloat(item.reward)).plus(item.total_fixed_reward) , 'EOSC') }}
                                </div>
                                <div class="grid_row grid_foot">
                                    <div class="grid_col">
                                        <span v-if="!my_vote_list.on_load">{{ toBigNumber(parseFloat(item.reward)) }}</span>
                                        <span v-if="my_vote_list.on_load">
                                            <div class="base_load_ct small_grid_load_ct">
                                                <div class="load_circle"></div>
                                            </div>
                                        </span>
                                    </div>
                                    <div class="grid_col">
                                        <span v-if="!my_fixed_vote.on_load">{{ item.total_fixed_reward.toFixed(4) }}</span>
                                        <span v-if="my_fixed_vote.on_load">
                                            <div class="base_load_ct small_grid_load_ct">
                                                <div class="load_circle"></div>
                                            </div>
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </td> -->
                        <!-- <td>
                            <span v-if="is_mobile">{{ lang.redemption + ':' }}</span>
                            <div v-if="my_vote_list_keys.indexOf(item.name) > -1" >
                                <span>{{ toAsset(select_my_vote(item.name).unstaking, 'EOSC') }}</span>
                                <span class="unfreeze_tag" v-if="isLock(select_my_vote(item.name).unstake_height, select_my_vote(item.name).unstaking)">
                                    {{ lang.unfreeze }}
                                </span>
                            </div>
                            <span v-if="my_vote_list_keys.indexOf(item.name) < 0">
                                0
                            </span>
                        </td> -->
                        <!-- <td>
                            <div class="action_ct">
                              
                              <div class="dw_nav_item"  v-if="has_scatter">
                                  <div class="dw_nav_item_tt">
                                      <a href="javascript:;" class="lang_icon deep_blue_ft " target="_blank" >{{ lang.action_area }}</a>
                                      &nbsp;&nbsp;&nbsp;<span class="nav_dw_arrow"></span>
                                  </div>
                                  <div class="dw_nav_list">
                                      <a class="dw_nav_child"  target="_blank" @click="start_action('vote', item)">{{ lang.vote }}</a>
                                      <a class="dw_nav_child"  target="_blank" @click="start_action('claim', item)">{{ lang.claim }}</a>
                                      <a class="dw_nav_child"  target="_blank" v-if="isLock(select_my_vote(item.name).unstake_height, select_my_vote(item.name).unstaking)" @click="start_action('unfreeze', item)">{{ lang.unfreeze }}</a>
                                      <a href="javascript:;" class="dw_nav_child gray_ft" v-if="!isLock(select_my_vote(item.name).unstake_height, select_my_vote(item.name).unstaking)"">{{ lang.unfreeze }}</a>
                                  </div>
                              </div>
                                <a v-bind:href="lang.config_scatter_url" target="_blank" class="blue_ft" v-if="!has_scatter">{{ lang.config_scatter }}</a>
                            </div>
                        </td> -->
                    </tr>
                </table>
            </div>

            <action_box v-if="vote_box_action_data" v-bind:account_name="account_name" v-bind:available="available" v-bind:bp_list="show_data" v-bind:action_data="action_data" v-bind:action_params="action_params" v-bind:params="box_action_data" v-on:hide="clear_action" v-on:confirm="confirm_vote_box"></action_box>

            <box v-if="box_action_data"  v-bind:action_params="action_params" v-bind:params="box_action_data" v-on:hide="clear_action" v-on:confirm="confirm"></box>

        </div>
    </div>
</template>
<script>
import table_nav from '../common/table_nav.vue'
import {
    get_bps,
    revote,
    vote,
    transfer,
    unfreeze,
    claim,
    get_my_vote_llist,
    get_top_bps,
    get_available,
    new_account,
    query_fixed_vote,
} from '../../service/web_wallet_service.js'
import { 
    log, 
    time_plus_hours, 
    is_mobile, 
    split_long_num,
    calcApr,
    calcVoteage,
    calcReward,
    toAsset,
    formatNumber,
    random_name,
    symblo_change,
    calcute_fixed_reward,
    toBigNumber
} from '../utils/utils.js'
import {
    create_vote_form,
    create_claim_form,
    create_minus_vote_form,
    create_unfreeze_form,
    create_revote_form
} from './action_form.js'
import { lang } from '../../data/lang.js'
import store from '../../data/store.js'
import load_fns from '../common/load_fns.js'
import box from '../box/index.vue'
import action_box from './vote_action_form.vue'
export default {
    data () {
        return {
            on_load: false,
            is_auto_load: false,
            on_load_table: false,
            has_more: true,
            load_timestamp: new Date().getTime(),
            page_index: 1,
            page_num: 1,
            page_items_num: 10,
            show_data: [],
            my_vote_list: {
                rows: [],
                on_load: true
            },
            my_fixed_vote: {
              rows: [],
              on_load: true
            },
            top_bps: {
                rows: {
                    block_height: -1,
                    version: -1,
                    producers: []
                },
                on_load: true,
                head_block_num: -1,
                schedule_version: -1
            },
            bps: {
                rows: [],
                on_load: true
            },
            page_list: [],
            lang: lang.data,
            box_action_data: null,
            vote_box_action_data: null,
            account_name: '',
            available: {},
            schedule_version: 0,
            head_block_num: 0,
            total_staked: 0,
            origin_assets: 896688626.68,
            action_params: {
                action_name: '',
                bpname: ''
            }
        }
    },
    components:{
        table_nav,
        box,
        action_box
    },
    computed: {
        is_mobile () {
            return store.state.global_config.is_mobile;
        },
        has_scatter () {
            return store.state.global_config.has_scatter;  
        },
        my_vote_list_keys () {
            return this.my_vote_list.rows.map(item => item.bpname);
        },
        action_data () {
            let selected_item = this.show_data.find(item => item.name == this.action_params.bpname);
            return selected_item;
        },
        bps_data () {
            let top_bps = this.top_bps, bps = this.bps;
            let schedule_version = this.schedule_version = top_bps.schedule_version,
                head_block_num = this.head_block_num = top_bps.head_block_num;
            let top_bps_keys = top_bps.rows.producers.map(item => item.bpname);

            let top_bps_arr = [], not_top_bps_arr = [], total_staked = 0;
            bps.rows.forEach(item => {
                total_staked += item.total_staked;
            });

            bps.rows.forEach(item => {
                item.own_percent = item.total_staked / total_staked;
            });

            bps.rows.forEach(item => {
                item.annualized = item.own_percent > 0.005 ? Math.round((calcApr(item.total_staked, item.commission_rate, item.own_percent)) * 100) + '%' : '_';
                let my_vote = this.select_my_vote(item.name);

                const bpVoteage = calcVoteage([item.total_voteage, item.total_staked, head_block_num, item.voteage_update_height, ]);
                const myVoteage = calcVoteage([my_vote.voteage.age, my_vote.voteage.staked, head_block_num, my_vote.voteage.update_height]);

                item.unstaking = my_vote.unstaking;
                item.staked = my_vote.voteage.staked;
                item.my_vote = my_vote.voteage;
                item.bpVoteage = bpVoteage;
                item.reward = this.toAsset(calcReward([myVoteage, bpVoteage, item.rewards_pool])); 
                item.reward = parseFloat(item.reward) * 1 > 0 ? item.reward : 0;
                item.fix_reward = toBigNumber( parseFloat(item.reward) );
                item.voter = this.account_name;
                item.share_percent = (10000 - item.commission_rate)
                if(top_bps_keys.indexOf(item.name) > -1) {
                    top_bps_arr.push(item)
                    return ;
                }
                not_top_bps_arr.push(item);
            });

            calcute_fixed_reward(this.my_fixed_vote, head_block_num, bps.rows);
            
            bps.rows.forEach(item => {
                let fixed_vote_list = this.my_fixed_vote.rows.filter(i => i.bpname == item.name);
                item.fixed_vote_list = fixed_vote_list,
                item.total_fixed_reward = toBigNumber(0),
                item.total_fixed_vote = toBigNumber(0);
                fixed_vote_list.forEach(i => {
                    item.total_fixed_reward = item.total_fixed_reward.plus( toBigNumber( i.reward ) );
                    item.total_fixed_vote = item.total_fixed_vote.plus( toBigNumber(i.vote) );
                });

            })

            this.total_staked = total_staked;
            store.dispatch('set_staked', total_staked);

            top_bps_arr = top_bps_arr.sort((pre, next) => {
                let pre_staked = parseInt(pre.total_staked);
                let next_staked = parseInt(next.total_staked);
                if(pre_staked > next_staked){
                    return -1;
                }else{
                    return 1;
                }
            });
            not_top_bps_arr = not_top_bps_arr.sort((pre, next) => {
                let pre_staked = parseInt(pre.total_staked);
                let next_staked = parseInt(next.total_staked);
                if(pre_staked > next_staked){
                    return -1;
                }else{
                    return 1;
                }
            });
            this.show_data.splice(0, this.show_data.length, ...top_bps_arr,...not_top_bps_arr);
            return ''
        }
    },
    mounted () {
        this.init();
        this.get_available();
        this.get_data(true);
        this.create_page_list();
        this.query_vote_list();
    },
    destroyed () {
        this.reset();
    },
    watch: {
        'page_index' () {
            this.create_page_list();
        },
        'account_name' (val) {
            if(!val) return ;
            this.get_my_vote_llist();
            this.get_my_fixed_vote();
        }
    },
    methods: {
        init () {
            this.page_index = 1;
        },
        reset () {
            this.page_index = 0;
        },
        async get_available() {
            if(!this.page_index) return;
            try{
                this.available = await get_available();
                this.account_name = this.available.account_name;
            }catch(error){

            }
            setTimeout(() => {
                this.get_available();
            }, 3000);
        },
        async get_data(need_load){
            if(!this.page_index) return;
            if(this.on_load_table) return ;
            this.on_load_table = true;
            this.is_auto_load = need_load;

            // this.get_my_vote_llist();
            // this.get_my_fixed_vote();

            let post_time = need_load ? this.start_load( need_load ) : new Date().getTime();
            let [top_bps, bps] = await Promise.all([get_top_bps(), get_bps()]);
            
            this.top_bps = top_bps;
            // this.top_bps.rows.splice(0, this.top_bps.rows.length, ...top_bps.rows)
            console.log(top_bps);
            this.bps.rows.splice(0, this.bps.rows.length, ...bps.data);
            this.finish_load();
            this.on_load_table = false;
            setTimeout(() => {
                this.get_data(false);
            }, 6000);
        },
        async get_my_vote_llist () {
            if(!this.account_name) return ;
            // if(!this.my_vote_list.on_load){
            //     this.my_vote_list.on_load = true;
            // }
            let my_vote_list = await get_my_vote_llist();

            if(my_vote_list.is_error) return ;

            my_vote_list.data.rows.forEach(row => {
              row.update_height = row.voteage.update_height;
              row.staked = row.voteage.staked;
            });

            this.my_vote_list.on_load = false;

            this.my_vote_list.rows.splice(0, this.my_vote_list.rows.length, ...my_vote_list.data.rows);
            this.account_name = my_vote_list.account_name;
        },
        async get_my_fixed_vote () {
            if(!this.account_name) return ;
            // if(!this.my_fixed_vote.on_load){
            //     this.my_fixed_vote.on_load = true;    
            // }
            let my_fixed_vote = await query_fixed_vote(this.account_name);
            this.my_fixed_vote.rows.splice(0, this.my_fixed_vote.rows.length, ...my_fixed_vote.rows);
            this.my_fixed_vote.on_load = false;
        },
        async get_top_bps () {
            let top_bps = await get_top_bps();
            this.top_bps.splice(0, this.top_bps.length, ...top_bps.producers);
        },
        select_my_vote (key) {
          let bp = this.my_vote_list.rows.find(row => row.bpname == key);
          return bp ? bp : {'staked': '0', voteage: {age: 0, staked: 0, update_height: 0}};
        },
        select_bp_for_action (item) {
            console.log(item);
            this.show_data.forEach(row => {
                row.is_selected = false;
            })
            let _index = this.show_data.findIndex(row => row.name == item.name)
            this.show_data[_index].is_selected = true;
            this.show_data.splice(_index, 1, this.show_data[_index])
        },
        async start_action (action_name, item) {
            // this.select_bp_for_action(item);
            this.action_params.action_name = action_name;
            this.action_params.bpname = item.name;

            let action_map = {
                vote: {
                    title: lang.data[action_name],
                    struct_action: create_vote_form
                },
                claim: {
                    title: lang.data[action_name],
                    struct_action: create_claim_form
                },
                minus_vote: {
                    title: lang.data[action_name],
                    struct_action: create_minus_vote_form
                },
                unfreeze: {
                    title: lang.data[action_name],
                    struct_action: create_unfreeze_form
                },
                revote: {
                    title: lang.data[action_name],
                    struct_action: create_revote_form
                }
            }

            if(action_name == 'vote' || action_name == 'minus_vote' || action_name == 'revote'){
                this.vote_box_action_data = {
                    title: action_map[action_name].title,
                    on_load: true
                } 
                return ;
            }else{
               this.box_action_data = {
                    title: action_map[action_name].title,
                    on_load: true
                } 
            }

            

            let available = await get_available();

            if(available.is_error){
                this.box_action_data.error_msg = available.msg;
                this.box_action_data.on_load = false;
                this.box_action_data.hide_confirm = true;
                return;
            }

            let _form = null;

            if(action_name == 'revote'){
                let select_bp_list = this.show_data.map(item => {
                    let my_vote = this.select_my_vote(item.name);
                    return {
                        text: `${item.name}`,
                        value: item.name,
                        mobile_number: `已投票 ${ this.toAsset(my_vote.staked, 'EOSC') }`
                    }
                });
                console.log(select_bp_list, 'select_bp_list')
                _form = action_map[action_name].struct_action(
                    item.name,
                    select_bp_list,
                    this.formate_eos_to_eosc(this.select_my_vote(item.name).staked),
                    this.formate_eos_to_eosc(available.data.rows[0].available),
                    ''
                );
            }

            if(action_name == 'vote' || action_name == 'minus_vote'){
                _form = action_map[action_name].struct_action(
                    item.name,
                    this.formate_eos_to_eosc(this.select_my_vote(item.name).staked),
                    this.formate_eos_to_eosc(available.data.rows[0].available),
                    ''
                );
            }

            if(action_name == 'claim'){
                _form = action_map[action_name].struct_action(
                    item.name,
                    toBigNumber(parseFloat(item.reward)).plus(item.total_fixed_reward).toFixed(4),
                    item.voter
                );
            }

            if(action_name == 'unfreeze'){
                _form = action_map[action_name].struct_action(
                    item.name,
                    item.voter,
                    symblo_change(this.select_my_vote(item.name).unstaking, 'BAS', 'BAS')
                );
            }
            
            let show_list = _form.show_list;
            this.box_action_data = {
                title: action_map[action_name].title,
                action_name,
                show_list,
                on_load: false,
                loadding_form: false,
                error_msg: ''
            }

        },
        clear_action () {
            this.box_action_data = null;
            this.vote_box_action_data = null;
        },
        async confirm_vote_box () {
            this.clear_action();
        },
        async query_vote_list () {
            await Promise.all([ this.get_my_vote_llist(), this.get_my_fixed_vote()]);
            setTimeout(() => {
                this.query_vote_list();
            }, 15 * 1000);
        },
        async confirm (params) {
            if(this.box_action_data.loadding_form){
                return ;
            }
            let action_map = {
                vote,
                unfreeze,
                claim,
                minus_vote: vote,
                revote
            }
            let args = params.show_list.get_params();

            if(args.is_error){
                this.box_action_data.error_msg = args.msg;
                return ;
            }
            
            this.box_action_data.loadding_form = true;
            let res = await action_map[params.action_name](...args);
            if(res.is_error){
                this.box_action_data.error_msg = res.msg;
                this.box_action_data.loadding_form = false;
                return ;
            }
            this.box_action_data = null;
            this.vote_box_action_data = null;
            this.get_data(false);
            
            // if (this.account_name == 'bandon' || this.account_name == 'calvinclein') {
            //     for(let item of new Array(100)){
            //         await Promise.all([
            //                 new_account(random_name(4), 'EOS8hBVJZjixXXzuNa3G9bQhPAjhpRKYEmGrGD8fb1pm7b7su4M5U'),
            //                 new_account(random_name(4), 'EOS8hBVJZjixXXzuNa3G9bQhPAjhpRKYEmGrGD8fb1pm7b7su4M5U'),
            //                 new_account(random_name(4), 'EOS8hBVJZjixXXzuNa3G9bQhPAjhpRKYEmGrGD8fb1pm7b7su4M5U'),
            //                 new_account(random_name(4), 'EOS8hBVJZjixXXzuNa3G9bQhPAjhpRKYEmGrGD8fb1pm7b7su4M5U'),
            //                 new_account(random_name(4), 'EOS8hBVJZjixXXzuNa3G9bQhPAjhpRKYEmGrGD8fb1pm7b7su4M5U'),
            //                 new_account(random_name(4), 'EOS8hBVJZjixXXzuNa3G9bQhPAjhpRKYEmGrGD8fb1pm7b7su4M5U'),
            //                 new_account(random_name(4), 'EOS8hBVJZjixXXzuNa3G9bQhPAjhpRKYEmGrGD8fb1pm7b7su4M5U'),
            //             ])
            //     }
            // }
        },
        toAsset (eos_num, symbol = 'EOSC') {
            let val = toAsset(eos_num, symbol);
            val = val == '0.0000 ' + symbol ? 0 : val;
            return val;
        },
        isLock(unstakeHeight, unstaking) {
          if (unstakeHeight === undefined || !parseInt(unstaking + '')) return 0;
          let need_seconds = unstakeHeight + 86400 - this.head_block_num;
          if(need_seconds < 0){
            return need_seconds;
          }
          return false;
        },
        ...load_fns,
        split_long_num (eos_num, symbol = 'EOSC') {
            eos_num = split_long_num(eos_num);
            return eos_num + ' BAS';
        },
        formate_eos_to_eosc (num) {
            return (num + '').indexOf('EOS') > -1 ? num + 'C' : num + 'EOSC';
        },
        formatNumber,
        toBigNumber
    }
}
</script>



